import * as i0 from '@angular/core';
import { NgModule, Injectable } from '@angular/core';
import { CommonModule } from '@angular/common';
import * as i1 from '@annuadvent/ngx-tools/fire-common';
import * as i2 from '@angular/common/http';
import { HttpParams } from '@angular/common/http';

class FireStoreModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FireStoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.0", ngImport: i0, type: FireStoreModule, imports: [CommonModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FireStoreModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FireStoreModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    providers: [],
                    imports: [
                        CommonModule
                    ]
                }]
        }] });

const RUN_QUERY_KEYWORD = ':runQuery';
const BIN_COLLECTION_POSTFIX = '-bin';

var StructuredQueryDirectionEnum;
(function (StructuredQueryDirectionEnum) {
    StructuredQueryDirectionEnum["DIRECTION_UNSPECIFIED"] = "DIRECTION_UNSPECIFIED";
    StructuredQueryDirectionEnum["ASCENDING"] = "ASCENDING";
    StructuredQueryDirectionEnum["DESCENDING"] = "DESCENDING";
})(StructuredQueryDirectionEnum || (StructuredQueryDirectionEnum = {}));
var StructuredQueryOperatorEnum;
(function (StructuredQueryOperatorEnum) {
    StructuredQueryOperatorEnum["OPERATOR_UNSPECIFIED"] = "OPERATOR_UNSPECIFIED";
    StructuredQueryOperatorEnum["AND"] = "AND";
    StructuredQueryOperatorEnum["LESS_THAN"] = "LESS_THAN";
    StructuredQueryOperatorEnum["LESS_THAN_OR_EQUAL"] = "LESS_THAN_OR_EQUAL";
    StructuredQueryOperatorEnum["GREATER_THAN"] = "GREATER_THAN";
    StructuredQueryOperatorEnum["GREATER_THAN_OR_EQUAL"] = "GREATER_THAN_OR_EQUAL";
    StructuredQueryOperatorEnum["EQUAL"] = "EQUAL";
    StructuredQueryOperatorEnum["NOT_EQUAL"] = "NOT_EQUAL";
    StructuredQueryOperatorEnum["ARRAY_CONTAINS"] = "ARRAY_CONTAINS";
    StructuredQueryOperatorEnum["IN"] = "IN";
    StructuredQueryOperatorEnum["ARRAY_CONTAINS_ANY"] = "ARRAY_CONTAINS_ANY";
    StructuredQueryOperatorEnum["NOT_IN"] = "NOT_IN";
    StructuredQueryOperatorEnum["IS_NAN"] = "IS_NAN";
    StructuredQueryOperatorEnum["IS_NULL"] = "IS_NULL";
    StructuredQueryOperatorEnum["IS_NOT_NAN"] = "IS_NOT_NAN";
    StructuredQueryOperatorEnum["IS_NOT_NULL"] = "IS_NOT_NULL";
})(StructuredQueryOperatorEnum || (StructuredQueryOperatorEnum = {}));
var StructuredQueryValueType;
(function (StructuredQueryValueType) {
    StructuredQueryValueType["nullValue"] = "nullValue";
    StructuredQueryValueType["booleanValue"] = "booleanValue";
    StructuredQueryValueType["integerValue"] = "integerValue";
    StructuredQueryValueType["doubleValue"] = "doubleValue";
    StructuredQueryValueType["timestampValue"] = "timestampValue";
    StructuredQueryValueType["stringValue"] = "stringValue";
    StructuredQueryValueType["bytesValue"] = "bytesValue";
    StructuredQueryValueType["referenceValue"] = "referenceValue";
    StructuredQueryValueType["geoPointValue"] = "geoPointValue";
    StructuredQueryValueType["arrayValue"] = "arrayValue";
    StructuredQueryValueType["mapValue"] = "mapValue";
})(StructuredQueryValueType || (StructuredQueryValueType = {}));
;

;
;

;

class FirestoreParserService {
    constructor() { }
    getFireStoreProp(value) {
        const props = [
            'arrayValue',
            'bytesValue',
            'booleanValue',
            'doubleValue',
            'geoPointValue',
            'integerValue',
            'mapValue',
            'nullValue',
            'referenceValue',
            'stringValue',
            'timestampValue',
            'fields',
            'document'
        ];
        return Object.keys(value).find(k => props.includes(k));
    }
    parse(value) {
        // Remove readTime
        if (value instanceof Array) {
            if (value.length === 1 && typeof value[0] === 'object' && Object.keys(value[0]).includes('readTime') && Object.keys(value[0]).length === 1) {
                value.splice(0, 1);
            }
        }
        if (typeof value === 'object') {
            const objKeys = Object.keys(value);
            if (objKeys.includes('readTime'))
                delete value.readTime;
        }
        const prop = this.getFireStoreProp(value);
        if (prop === 'doubleValue' || prop === 'integerValue') {
            value = Number(value[prop]);
        }
        else if (prop === 'arrayValue') {
            value = (value[prop] && value[prop].values || []).map((v) => this.parse(v));
        }
        else if (prop === 'mapValue') {
            value = this.parse(value[prop] && value[prop].fields || {});
        }
        else if (prop === 'geoPointValue') {
            value = { latitude: 0, longitude: 0, ...value[prop] };
        }
        // extract and add id to the document.
        else if (prop === 'fields') {
            const nextValue = value[prop];
            const docName = value.name;
            if (docName && nextValue) {
                const docId = docName.substring(docName.lastIndexOf('/') + 1);
                value[prop].id = docId;
            }
            value = this.parse(value[prop]);
        }
        else if (prop === 'document') {
            const nextValue = value[prop];
            const docName = nextValue.name;
            if (docName && nextValue.fields) {
                const docId = docName.substring(docName.lastIndexOf('/') + 1);
                value[prop].fields.id = docId;
            }
            value = this.parse(value[prop]);
        }
        else if (prop) {
            value = value[prop];
        }
        else if (typeof value === 'object') {
            Object.keys(value).forEach(k => value[k] = this.parse(value[k]));
        }
        return value;
    }
    buildFirebaseFields(doc, fieldsToUpdate) {
        if (!doc)
            throw new Error('Please provide a valid document object containing one or more fields.');
        const firebaseDoc = {
            fields: {}
        };
        if (fieldsToUpdate && fieldsToUpdate.length) {
            const missingPropsOnDoc = [];
            fieldsToUpdate.forEach(fieldName => {
                const fieldValue = doc[fieldName];
                // ensures fieldsToUpdate field has its property on doc, else remove it from fields to update.
                if (typeof fieldValue !== 'undefined') {
                    firebaseDoc.fields[fieldName] = this.getFieldStructuredValue(fieldValue);
                }
                else {
                    missingPropsOnDoc.push(fieldName);
                }
            });
            // remove missing props (undefined) from the fieldsToUpdate. As firestore does not update missing properties.
            fieldsToUpdate = fieldsToUpdate.filter(fieldName => !missingPropsOnDoc.includes(fieldName));
        }
        else {
            firebaseDoc.fields = this.getFieldStructuredValue(doc).mapValue.fields;
        }
        return firebaseDoc;
    }
    getFieldStructuredValue(value) {
        let valueType;
        if (typeof value === 'number') {
            valueType = StructuredQueryValueType.doubleValue;
        }
        else if (typeof value === 'string') {
            valueType = StructuredQueryValueType.stringValue;
        }
        else if (typeof value === 'boolean') {
            valueType = StructuredQueryValueType.booleanValue;
        }
        else if (value instanceof Array) {
            valueType = StructuredQueryValueType.arrayValue;
            const arrayValue = { values: [] };
            value.forEach(itemValue => {
                arrayValue.values.push(this.getFieldStructuredValue(itemValue));
            });
            value = arrayValue;
        }
        else if (typeof value === 'object') {
            valueType = StructuredQueryValueType.mapValue;
            const mapValue = { fields: {} };
            Object.keys(value).forEach(key => mapValue.fields[key] = this.getFieldStructuredValue(value[key]));
            value = mapValue;
        }
        const structuredQueryValue = { [valueType]: value };
        return structuredQueryValue;
    }
    buildQueryParamsToUpdate(fieldsToUpdate) {
        let params = new HttpParams();
        fieldsToUpdate?.forEach(fieldName => {
            params = params.append('updateMask.fieldPaths', fieldName);
        });
        return params;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreParserService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreParserService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreParserService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class FirestoreQueryService {
    constructor(fireCommonService) {
        this.fireCommonService = fireCommonService;
    }
    getSelectFields(selectFields) {
        return {
            fields: selectFields.map(field => ({ fieldPath: field }))
        };
    }
    getOrderBy(orderBy) {
        return orderBy.map(orderByField => {
            let { fieldPath, isDesc } = orderByField;
            if (orderByField.fieldPath === 'id') {
                fieldPath = '__name__';
            }
            return {
                field: { fieldPath: fieldPath },
                direction: isDesc === true ? StructuredQueryDirectionEnum.DESCENDING : StructuredQueryDirectionEnum.ASCENDING
            };
        });
    }
    getStartPage(startPage, orderBy) {
        const values = orderBy.map((orderField, index) => ({ [orderField.fieldType]: startPage[index] || 'null' }));
        return {
            values,
            before: false
        };
    }
    getWhere(where, collectionId) {
        const firestoreApiUrl = this.fireCommonService.firebaseConfig?.store?.firestoreBaseApiUrl;
        const filters = where.map(fireFilter => {
            let { fieldPath, operator, value, valueType } = fireFilter;
            if (value === null || typeof value === 'undefined') {
                return null;
            }
            /*
            * If Where has a filter for id, that means it has to be filtered on document's __name__ reference fieldpath.
            * Also __name__ has to be in orderBy. So add it to orderBy separately.
           */
            if (fieldPath === 'id') {
                const collectionUrl = firestoreApiUrl.substring(firestoreApiUrl.indexOf('/projects/') + 1);
                fieldPath = '__name__';
                value = value instanceof Array ?
                    value.map(val => `${collectionUrl}/${collectionId}/${val}`) :
                    `${collectionUrl}/${collectionId}/${value}`;
                valueType = StructuredQueryValueType.referenceValue;
            }
            return {
                fieldFilter: {
                    field: { fieldPath: fieldPath },
                    op: operator,
                    value: value instanceof Array ?
                        { arrayValue: { values: value.map(v => ({ [valueType]: v })) } } :
                        { [valueType]: value },
                }
            };
        });
        const validFilters = filters.filter(ft => ft !== null);
        if (validFilters && validFilters.length) {
            return {
                compositeFilter: {
                    filters,
                    op: StructuredQueryOperatorEnum.AND
                }
            };
        }
        else {
            return null;
        }
    }
    fireToStructuredQuery(fireQuery) {
        if (!fireQuery)
            throw new Error('Invalid Fire Query.');
        let { collectionId, selectFields, orderBy, where, isForwardDir, startPage, pageSize } = fireQuery;
        let squery = {
            from: [{ collectionId, allDescendants: false }]
        };
        /*
        * If id is in the where filters, then add id(__name__) to orderBy, its mandatory.
        */
        if (where && where.length && where.find(filter => filter.fieldPath === 'id')) {
            orderBy = orderBy ? [...orderBy] : [];
            // if not, id orderBy already exist, then add it to order By
            if (!orderBy.find(ord => ord.fieldPath === 'id')) {
                orderBy.push({
                    fieldPath: 'id',
                    fieldType: StructuredQueryValueType.referenceValue,
                    isDesc: true,
                });
            }
        }
        if (selectFields && selectFields.length) {
            squery.select = this.getSelectFields(selectFields);
        }
        if (orderBy && orderBy.length) {
            squery.orderBy = this.getOrderBy(orderBy);
        }
        if (startPage && startPage.length && orderBy && orderBy.length && pageSize > 0) {
            if (isForwardDir === false) {
                squery.endAt = this.getStartPage(startPage, orderBy);
            }
            else {
                squery.startAt = this.getStartPage(startPage, orderBy);
            }
        }
        if (pageSize > 0) {
            squery.limit = pageSize;
        }
        if (where && where.length) {
            const validWhere = this.getWhere(where, collectionId);
            if (validWhere) {
                squery.where = validWhere;
            }
        }
        return { structuredQuery: squery };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreQueryService, deps: [{ token: i1.FireCommonService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreQueryService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreQueryService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.FireCommonService }]; } });

class FirestoreHttpService {
    constructor(fireCommonService, http, firestoreParser, firestoreQueryService) {
        this.fireCommonService = fireCommonService;
        this.http = http;
        this.firestoreParser = firestoreParser;
        this.firestoreQueryService = firestoreQueryService;
    }
    async runQueryById(collectionId, id) {
        const firestoreApiUrl = this.fireCommonService.firebaseConfig?.store?.firestoreBaseApiUrl;
        return new Promise((resolve, reject) => {
            if (!collectionId || !id) {
                reject('Please provide a valid collection id and document id.');
            }
            else {
                const url = `${firestoreApiUrl}/${collectionId}/${id}`;
                const httpSubscription = this.http.get(url).subscribe({
                    next: (queryResult) => {
                        const parsedQueryResult = this.firestoreParser.parse(queryResult);
                        httpSubscription.unsubscribe();
                        resolve(parsedQueryResult);
                    },
                    error: reject,
                });
            }
        });
    }
    async runQueryByConfig(fireQuery) {
        const firestoreApiUrl = this.fireCommonService.firebaseConfig?.store?.firestoreBaseApiUrl;
        return new Promise((resolve, reject) => {
            const url = `${firestoreApiUrl}${RUN_QUERY_KEYWORD}`;
            const httpSubscription = this.http
                .post(url, this.firestoreQueryService.fireToStructuredQuery(fireQuery))
                .subscribe({
                next: (queryResult) => {
                    const parsedQueryResult = this.firestoreParser.parse(queryResult);
                    httpSubscription.unsubscribe();
                    resolve(parsedQueryResult);
                },
                error: (err) => reject({ config: fireQuery, error: err }),
            });
        });
    }
    async runQueryToUpdate(collectionId, collectionDoc, fieldsToUpdate, isBin = false) {
        const firestoreApiUrl = this.fireCommonService.firebaseConfig?.store?.firestoreBaseApiUrl;
        if (!collectionDoc || !collectionDoc.id)
            throw new Error('Please provide a valid collection document');
        // If update to Bin collection, then postfix collectionId with '-bin'
        if (isBin === true)
            collectionId = `${collectionId}${BIN_COLLECTION_POSTFIX}`;
        const pCollectionDoc = { ...collectionDoc };
        delete pCollectionDoc.id;
        return new Promise((resolve, reject) => {
            const url = `${firestoreApiUrl}/${collectionId}/${collectionDoc.id}`;
            const body = this.firestoreParser.buildFirebaseFields(pCollectionDoc, fieldsToUpdate);
            const params = this.firestoreParser.buildQueryParamsToUpdate(fieldsToUpdate);
            const httpSubscription = this.http
                .patch(url, body, { params })
                .subscribe({
                next: (queryResult) => {
                    const updatedCollectionDoc = this.firestoreParser.parse(queryResult);
                    httpSubscription.unsubscribe();
                    resolve(updatedCollectionDoc);
                },
                error: reject,
            });
        });
    }
    async runQueryToDelete(collectionId, collectionDoc) {
        const firestoreApiUrl = this.fireCommonService.firebaseConfig?.store?.firestoreBaseApiUrl;
        if (!collectionDoc || !collectionDoc.id)
            throw new Error('Please provide a valid collectionDoc.');
        return new Promise((resolve, reject) => {
            // Copy to collectionDocs bin, then delete from collectionDocs db.
            this.runQueryToUpdate(collectionId, collectionDoc, null, true)
                .then(() => {
                const url = `${firestoreApiUrl}/${collectionId}/${collectionDoc.id}`;
                // delete from collectionDocs db.
                const httpSubscription = this.http.delete(url).subscribe({
                    next: (res) => {
                        httpSubscription.unsubscribe();
                        resolve(true);
                    },
                    error: reject,
                });
            })
                .catch(reject);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreHttpService, deps: [{ token: i1.FireCommonService }, { token: i2.HttpClient }, { token: FirestoreParserService }, { token: FirestoreQueryService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreHttpService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.0", ngImport: i0, type: FirestoreHttpService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.FireCommonService }, { type: i2.HttpClient }, { type: FirestoreParserService }, { type: FirestoreQueryService }]; } });

// Export all exposable angular assets from ./src folder, like components, services, pipes, directives etc.

/**
 * Generated bundle index. Do not edit.
 */

export { BIN_COLLECTION_POSTFIX, FireStoreModule, FirestoreHttpService, FirestoreParserService, FirestoreQueryService, RUN_QUERY_KEYWORD, StructuredQueryDirectionEnum, StructuredQueryOperatorEnum, StructuredQueryValueType };
//# sourceMappingURL=annuadvent-ngx-tools-fire-store.mjs.map
