import { Category } from '../interfaces/fire-categories.interface';
import { Article } from '../interfaces/fire-articles.interface';
import { PageCategoryGroup } from '../interfaces/fire-categories.interface';
import { PageArticles } from '../interfaces/fire-articles.interface';
import { UtilsService } from '@annuadvent/ngx-core/utils';
import { FirestoreHttpService } from '@annuadvent/ngx-tools/fire-store';
import * as i0 from "@angular/core";
export declare class FireArticlesHttpService {
    private utilsSvc;
    private firestoreHttpService;
    constructor(utilsSvc: UtilsService, firestoreHttpService: FirestoreHttpService);
    private buildPageOfArticles;
    getArticle(articleId: string): Promise<Article>;
    getLiveArticle(articleId: string): Promise<Article>;
    getUsersArticle(articleId: string, userId: string): Promise<Article>;
    getUsersOnePageShallowArticles(userId: string, isLive: boolean | null, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageArticles>;
    getAllUsersOnePageShallowArticles(isLive: boolean | null, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageArticles>;
    getUsersOnePageInReviewShallowArticles(userId: string, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageArticles>;
    getAllUsersOnePageInReviewShallowArticles(pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageArticles>;
    getLiveShallowArticlesOfCategories(categories: Array<string> | Array<Category>, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<Array<PageCategoryGroup>>;
    getAllLiveArticlesFromDate(fromDateTime: string): Promise<Array<Article>>;
    getLiveOnePageShallowArticlesByFeatures(features: Array<string>, isLive?: boolean, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageArticles>;
    addArticle(article: Article): Promise<Article>;
    updateArticle(article: Article): Promise<Article>;
    setArticleUpForReview(article: Article): Promise<Article>;
    setArticleLive(article: Article): Promise<Article>;
    deleteArticle(article: Article): Promise<boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<FireArticlesHttpService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FireArticlesHttpService>;
}
