import { UtilsService } from '@annuadvent/ngx-core/utils';
import { Category } from '../interfaces/fire-categories.interface';
import { FirestoreHttpService } from '@annuadvent/ngx-tools/fire-store';
import { PageCategories, PageCategoryGroup } from '../interfaces/fire-categories.interface';
import { FireArticlesHttpService } from './fire-articles-http.service';
import * as i0 from "@angular/core";
export declare class FireCategoriesHttpService {
    private utilsSvc;
    private firestoreHttpService;
    private fireArticlesHttpService;
    constructor(utilsSvc: UtilsService, firestoreHttpService: FirestoreHttpService, fireArticlesHttpService: FireArticlesHttpService);
    private buildPageOfCategories;
    getCategory(categoryId: string): Promise<Category>;
    getUsersCategory(userId: string, categoryId: string): Promise<Category>;
    getAllLiveShallowCategories(isLive?: boolean): Promise<Array<Category>>;
    getAllLiveCategoriesWithOnePageShallowArticles(pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<Array<PageCategoryGroup>>;
    getLiveCategoryWithOnePageShallowArticles(categoryId: string, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageCategoryGroup>;
    getUsersOnePageShallowCategories(userId: string, isLive: boolean | null, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageCategories>;
    getAllUsersOnePageShallowCategories(isLive: boolean | null, pageSize?: number, startPage?: string | null, isForwardDir?: boolean): Promise<PageCategories>;
    getShallowCategoriesByIds(categoryIds: Array<string>): Promise<Array<Category>>;
    getShallowLiveCategoriesByFeatures(features: string | Array<string>, isLive?: boolean): Promise<Array<Category>>;
    /**
     * Get all Live categories since the given last updated, by date.
     * @date 2/27/2023 - 6:40:21 PM
     *
     * @public
     * @async
     * @param {string} fromDateTime
     * @returns {Promise<Array<Category>>}
     */
    getAllLiveCategoriesFromDate(fromDateTime: string): Promise<Array<Category>>;
    addCategory(category: Category): Promise<Category>;
    updateCategory(category: Category): Promise<Category>;
    setCategoryUpForReview(category: Category): Promise<Category>;
    setCategoryLive(category: Category): Promise<Category>;
    deleteCategory(category: Category): Promise<boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<FireCategoriesHttpService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FireCategoriesHttpService>;
}
