import { ElementRef, OnInit } from '@angular/core';
import { ImageBrowserService } from '../../services/image-browser.service';
import { ImageFileInfo } from '../../interfaces/fire-storage-image.interface';
import { ImageBrowserLoadings, PreviewOnImages } from '../../interfaces/image-browser.interface';
import * as i0 from "@angular/core";
/**
 * Image Browser component allows logged in user to browse, select and upload images to fire store.
 * Image Browser is implemented upon Image Browser service (ImageBrowserService), that exposes observables
 * to listen to any changes to the components data.
 *
 * So It is recommended to use ImageBrowserService and its exposed observables to work with this component.
 */
export declare class ImageBrowserComponent implements OnInit {
    private imageBrowserService;
    fileEl: ElementRef;
    imageFiles: Array<ImageFileInfo>;
    selectedImageFile: ImageFileInfo;
    previewOnImages: PreviewOnImages;
    imagesFilesFiltered: Array<ImageFileInfo>;
    imagesFilesFilteredCount: number;
    uploadHelpText: string;
    choosenFileName: string;
    choosenFile: any;
    nextPageToken: any;
    error: any;
    loading: ImageBrowserLoadings;
    deleteConfirmModalOpened: boolean;
    toDeleteImageFile: ImageFileInfo;
    constructor(imageBrowserService: ImageBrowserService);
    ngOnInit(): void;
    private setErrorAndLoading;
    onImageListFilter(imageFilesFiltered: Array<object>): void;
    refreshClick(event: any): void;
    selectClick(event: any, imageFile: ImageFileInfo): void;
    loadMoreClick(event: any): void;
    deleteImageOkClick(): void;
    deleteImageCancelClick(): void;
    deleteClick(event: any, imageFile: ImageFileInfo): void;
    previewClick(event: any, imageFile: ImageFileInfo): void;
    onFileChange(event: any): void;
    uploadClick(): void;
    uploadFileClick(event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ImageBrowserComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ImageBrowserComponent, "anu-image-browser", never, { "imageFiles": { "alias": "imageFiles"; "required": false; }; }, {}, never, never, false, never, false>;
}
