import { FireCommonService } from '@annuadvent/ngx-tools/fire-common';
import { ImageFileInfo, ImageFileInfoList } from '../interfaces/fire-storage-image.interface';
import * as i0 from "@angular/core";
export declare class FireStorageImageService {
    private fireCommonService;
    baseStorageUrl: string;
    constructor(fireCommonService: FireCommonService);
    private buildImageUrl;
    getUploadImageValidationText(): string;
    validateImage(imageData: any): Promise<string>;
    validateImageDimension(imageData: any): Promise<string>;
    uploadImage(fullPathWithFileName: string, imageData: any, overWrite?: boolean, userId?: string, isBas64?: boolean): Promise<ImageFileInfo>;
    getImageUrl(fullPathWithFileName: string, userId?: string): Promise<string>;
    deleteImage(fullPathWithFileName: string, userId?: string): Promise<string>;
    getImagesList(userId?: string, pageSize?: number, nextPageToken?: any): Promise<ImageFileInfoList>;
    imageExists(fullPathWithFileName: string, userId?: string): Promise<boolean>;
    compressBase64ToJpeg(base64Image: string): Promise<Blob>;
    dataURItoBlob(dataURI: string, type: string): Blob;
    static ɵfac: i0.ɵɵFactoryDeclaration<FireStorageImageService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FireStorageImageService>;
}
