import { Observable } from 'rxjs';
import { ImageFileInfo } from '../interfaces/fire-storage-image.interface';
import { FireStorageImageService } from './fire-storage-image.service';
import { FireAuthService } from '@annuadvent/ngx-tools/fire-auth';
import { PreviewOnImages } from '../interfaces/image-browser.interface';
import * as i0 from "@angular/core";
export declare class ImageBrowserService {
    private fireStorageImageService;
    private fireAuthService;
    private imageFiles$;
    private selected$;
    private previewOnImages$;
    private _pageSize;
    userId: string;
    nextPageToken: any;
    uploadValidationText: string;
    constructor(fireStorageImageService: FireStorageImageService, fireAuthService: FireAuthService);
    private clear;
    get pageSize(): number;
    set pageSize(v: number);
    get imageFiles(): Observable<Array<ImageFileInfo>>;
    get selected(): Observable<ImageFileInfo>;
    get previewOnImages(): Observable<PreviewOnImages>;
    refreshList(): Promise<Array<ImageFileInfo>>;
    loadMore(): Promise<Array<ImageFileInfo>>;
    delete(imageFile: ImageFileInfo): Promise<ImageFileInfo>;
    upload(imagePathWithFileName: string, imageData: any): Promise<ImageFileInfo>;
    selectImageFile(imageFile: ImageFileInfo): void;
    previewImageFile(imageFullFileName: string, previewOn?: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ImageBrowserService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ImageBrowserService>;
}
