import { EventEmitter } from '@angular/core';
import { OpenaiService } from '../../services/openai.service';
import { FireStorageImageService, ImageFileInfo } from '@annuadvent/ngx-tools/fire-storage';
import { FireAuthService } from '@annuadvent/ngx-tools/fire-auth';
import * as i0 from "@angular/core";
export declare class OpenaiImageFormComponent {
    private openaiService;
    private fireStorageImageService;
    private fireAuthService;
    imagePromptText: string;
    imageFileName: string;
    imageGenerated: EventEmitter<string>;
    fileUploaded: EventEmitter<ImageFileInfo>;
    generatedBase64Image: string;
    savedImageUrl: string;
    loading: boolean;
    errorMsg: string;
    constructor(openaiService: OpenaiService, fireStorageImageService: FireStorageImageService, fireAuthService: FireAuthService);
    generateImage(): Promise<string>;
    uploadImage(): Promise<void>;
    private startLoading;
    private stopLoading;
    static ɵfac: i0.ɵɵFactoryDeclaration<OpenaiImageFormComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OpenaiImageFormComponent, "anu-openai-image-form", never, { "imagePromptText": { "alias": "imagePromptText"; "required": false; }; "imageFileName": { "alias": "imageFileName"; "required": false; }; }, { "imageGenerated": "imageGenerated"; "fileUploaded": "fileUploaded"; }, never, never, false, never, false>;
}
