import { OpenaiConfigurationTypeEnum } from "../enums/openai-http.enums";
export interface OpenaiConfigurationItem {
    type: OpenaiConfigurationTypeEnum;
    value: any;
    min?: number;
    max?: number;
    step?: number;
    rangeValues?: Array<string>;
}
export interface OpenaiConfiguration {
    baseApiUrl: OpenaiConfigurationItem;
    endpoints: OpenaiConfigurationItem;
    apiKey: OpenaiConfigurationItem;
    cleanupKeywords: OpenaiConfigurationItem;
    headers: OpenaiConfigurationItem;
    [key: string]: OpenaiConfigurationItem;
}
