import { Observable } from "rxjs";
import { QueueItem } from "./queue-item.class";
import { QueueStatusEnum } from "../enums/queue.enums";
export declare class Queue {
    private queue$;
    private currentBatch$;
    private status$;
    private timer$;
    private startTime;
    private batchSize;
    private minBatchTime;
    private failedDelay;
    private batchStartTime;
    private interval;
    constructor();
    get queueValue(): Array<QueueItem>;
    get currentBatchValue(): Array<QueueItem>;
    get statusValue(): QueueStatusEnum;
    get timerValue(): number;
    get queue(): Observable<Array<QueueItem>>;
    get currentBatch(): Observable<Array<QueueItem>>;
    get status(): Observable<QueueStatusEnum>;
    get timer(): Observable<number>;
    private getUniqueFromString;
    private find;
    private canAdd;
    private canRemove;
    private canUpdate;
    private canClear;
    private canStart;
    private canPause;
    private canResume;
    private canNotifyCurrentItems;
    private notifyQueueChange;
    private notifyBatchAndQueue;
    private notifyStatusChange;
    private notifyCurrentBatchChange;
    private getNextCurrentItems;
    add(items: Array<QueueItem>): void;
    remove(items: Array<QueueItem>): void;
    update(items: Array<QueueItem>): void;
    updateQueueBatch(items: Array<QueueItem>): void;
    start(batchSize?: number, minBatchTime?: number, // seconds
    failedDelay?: number): void;
    pause(): void;
    resume(): void;
    clear(): void;
}
