import { EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Queue } from '../../classes/queue.class';
import { QueueItem } from '../../classes/queue-item.class';
import { QueueStatusEnum } from '../../enums/queue.enums';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
/**
 * Visualizes the Queue running status, with counts and status for inprogress, paused, notstarted, failed and completeed.
 */
export declare class QueueStatusComponent implements OnInit, OnChanges, OnDestroy {
    queue: Queue;
    startClick: EventEmitter<void>;
    qItems: Array<QueueItem>;
    qStatus: QueueStatusEnum;
    totalCount: number;
    completedCount: number;
    notstartedCount: number;
    failedCount: number;
    inprogressCount: number;
    queueSubscription: Subscription;
    statusSubscription: Subscription;
    timerSubscription: Subscription;
    timeEllapsed: number;
    constructor();
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private subscribeQueue;
    private refreshQueueCounters;
    startClicked(event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<QueueStatusComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QueueStatusComponent, "anu-queue-status", never, { "queue": { "alias": "queue"; "required": false; }; }, { "startClick": "startClick"; }, never, ["*"], false, never, false>;
}
